<!-- -*- sgml -*- -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  
  <rules>
    <rule><query/LINUXDOC/ <isa/Document/
      <rule><query/ARTICLE/ <isa/Holder/
    <rule><query/TITLEPAG/ <isa/Holder/
      <rules>
	<rule><query/TITLE/ <save/{title}/
	<rule><query/AUTHOR/ <isa/Author/
	  <push/{authors}/
	  <rules>
	    <rule><query/NAME/ <save/{formattedname}/
	  </rules>
	<rule><query/DATE/ <save/{date}/
	<rule><query/ABSTRACT/ <save/{abstract}/
      </rules>
    </rule>

    <rule><query/SECT/ <isa/Section/
    <rule><query/SECT1/ <isa/Section/
    <rule><query/SECT2/ <isa/Section/
    <rule><query/SECT3/ <isa/Section/
    <rule><query/SECT4/ <isa/Section/
    <rule><query/HEADING/ <save/{title}/

    <rule><query/P/ <isa/Paragraph/
    <rule><query/TSCREEN/ <isa/Block/
    <rule><query/VERB/ <isa/Screen/
    <rule><query/CODE/ <isa/Screen/
    <rule><query/QUOTE/ <isa/BlockQuote/
    <rule><query/TABLE/ <isa/Formal ('type' => 'Table')/
      <rules>
        <rule><query/CAPTION/  <save/{title}/
      </rules>
    </rule>

<!-- this was an attemp to modify the LinuxDoc DTD to be:

<!element tabular - - (hline+)>
<!element hline  o o (rowsep+)>
<!element rowsep o o (colsep+)>
<!element colsep o o (#PCDATA)>

and it worked surprisingly well, except that an empty column:

801/805|AT&amp;T 20C490   |         | 16| Actix GE 32                     @
       |                  |         |   | Orchid Fahrenheit 1280+         @
801/805|AT&amp;T 20C490   |ICD2061A | 16| STB PowerGraph X.24             @

parses as a <COLSEP> start tag, whereas column separators are
effectively ``end tags''.  The end result is that a column is dropped:

801/805   AT&T                     16                Actix GE 32
          20C490                                     
                                   Orchid            
                                   Fahrenheit        
                                   1280+             
801/805   AT&T         ICD2061A    16                STB PowerGraph X.24
          20C490                                     

Although I disagree with the DTD design (columns and rows should be
elements not seperators) it is valid SGML and it should be possible to
have the DocObject deal with it, but that goes back on the ToDo list.
Here's the spec fragment I tried:

    <rule><query/TABULAR/ <isa/Table/
      <rules>
        <rule><query/HLINE/  <isa/TablePart/
        <rule><query/ROWSEP/ <isa/TableRow/
        <rule><query/COLSEP/ <isa/TableEntry/
      </rules>
    </rule>

 -->

    <rule><query/ENUM/ <isa/List ('type' => 'ordered')/
    <rule><query/ITEMIZE/ <isa/List ('type' => 'itemized')/
    <rule><query/DESCRIP/ <isa/List ('type' => 'variable')/
    <rule><query/TAG/ <isa/ListTerm/
    <rule><query/ITEM/ <isa/ListItem/

    <rule><query/TT/ <isa/Inline_Literal/
    <rule><query/CPARAM/ <isa/Inline_Emphasis/
    <rule><query/EM/ <isa/Inline_Emphasis/
    <rule><query/BF/ <isa/Inline/
    <rule><query/SF/ <isa/Inline/
    <rule><query/SL/ <isa/Inline/
    <rule><query/IT/ <isa/Inline/
      <!-- XXX this should use a CDATAATTR element -->
                                    <!-- XXX Eeeyeewww!! it's PERL! -->
    <rule><query/HTMLURL/ <isa>URL ('content' => [new_arr Text::GDO::SGML::Event('cdata',
                                                     (<attr/NAME/ =~ m'@@urlnam') ? "" : <attr/NAME/, undef, undef)],
                                    'url' => new_arr Text::GDO::SGML::Event ('cdata', <attr/URL/, undef, undef))</isa>
    <rule><query/URL/ <isa>URL ('content' => [new_arr Text::GDO::SGML::Event ('cdata',
                                                (<attr/NAME/ =~ m'@@urlnam') ? "" : <attr/NAME/, undef, undef)],
                                    'url' => new_arr Text::GDO::SGML::Event ('cdata', <attr/URL/, undef, undef))</isa>
    <rule><query/REF/ <isa>XRefEnd ('link' => <attr/ID/)</isa>
    <rule><query/NEWLINE/ <isa/Inline/

    <rule><query/LABEL/ <isa/Inline/
      
  <stuff>
sub save_attr {
    my ($self, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    # XXX oohh.. aack this is fugly.  LinuxDoc should use IDREF's
    # only save id if this is a LABEL
    if (($event->data->name eq "LABEL")
        && ($id_attr = $event->data->attribute ('ID'))) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            # LABEL occurs within a Block within a 'formal_title'able object
            new Text::GDO::Reference ($data, 'object' => $parent->{'parent'}->{'parent'}, 'id' => $id);
        }
    }
}
</stuff>
</spec>
