<!-- -*- sgml -*-

#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

 -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  <rules>
    <rule> <query/SROFF/            <isa/Document/

    <!-- Header Elements -->
    <rule> <query/HEAD/              <isa/Holder/
      <rules>
	<rule> <query/STRUCTTITLE/     <save/{title}/
	<rule> <query/STRUCTSUBTITLE/  <save/{sub_title}/
	<rule> <query/STRUCTAUTHOR/    <isa/Author/
	  <push/{authors}/
	<rule> <query/ABSTRACT/        <save/{abstract}/
	<rule> <query/COPYRIGHT/       <save/{copyright}/
	<rule> <query/STRUCTDATE/      <save/{date}/
	<rule> <query/STRUCTEXTRA/     <isa/Holder/
      </rules>
    </rule>

    <!-- Body Elements -->
    <rule> <query/SECTION/          <isa/Section/
    <rule> <query/TITLE/            <save/{title}/
    <rule> <query/PAR/              <isa/Paragraph/
    <rule> <query/SCREEN/	    <isa/Screen/
    <rule> <query/NOADJUST/         <isa/NoFill/
    <rule> <query/LINEANNOTATION/   <isa/Inline/
    <rule> <query/BLOCKQUOTE/       <isa/BlockQuote/
    <rule> <query/FIGURE/           <isa/Formal/
    <rule> <query/FIGURETITLE/      <save/{title}/

    <rule> <query/UL/                <isa/List ('type' => 'itemized')/
    <rule> <query/OL/                <isa/List ('type' => 'ordered')/
    <rule> <query/DL/                <isa/List ('type' => 'variable')/
    <rule> <query/LISTITEM/          <isa/ListItem/
    <rule> <query/LISTTERM/          <isa/ListTerm/

    <!-- Inline Elements -->
    <rule> <query/JINLINE/ <isa/Inline/
    <rule> <query/ITALIC/ <isa/Inline/
    <rule> <query/QITALIC/ <isa/Inline/
    <rule> <query/BOLD/  <isa/Inline/
    <rule> <query/QBOLD/ <isa/Inline/
    <rule> <query/TT/ <isa/Inline/
    <rule> <query/QTT/ <isa/Inline_Literal/
    <rule> <query/QUOTED/ <isa/Inline_Quote/
    <rule> <query/DQUOTED/ <isa/Inline/
    <rule> <query/SYMBOL/ <isa/Inline/
    <rule> <query/URL/ <isa>URL ('url' => new_arr Text::GDO::SGML::Event ('cdata', <attr/URL/, undef, undef))</isa>
    <rule> <query/LINK/ <isa>XRefEnd ('link' => <attr/LINKEND/)</isa>

  </rules>
  <stuff>
sub save_attr {
    my ($transform, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    if ($id_attr = $event->data->attribute ('ID')) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            $parent->{'id'} = $id;
            new Text::GDO::Reference ($data, 'object' => $parent, 'id' => $id);
        }
    }
}

package Text::GDO::DB_SGMLTag;
@Text::GDO::DB_SGMLTag::ISA = qw{Text::GDO::Inline};

sub as_string {
    my ($self, $context) = @_;

    return "<" . $self->{'source'}->as_string($context) . ">";
}
</stuff>
</spec>
